*:********************************************************************
*:
*: Procedure file :VIEW.PRG
*:
*: Contents :
*: 
*: 		Class     StatusBarView AS View
*: 		Class     MyView AS View
*: 		Class     View AS Form
*: 		Class     MyGrid AS Grid
*: 		Class     MyColumn AS Column
*: 		Class     MyHeader AS Header
*: 		Class     MyGridText AS TextBox
*:
*: (c) Piva, BEAR v.42 on 18.03.2003 11:25
*:********************************************************************
*
* 16.11.2000 00:00
*   View     MyGrid
*      
*

#include include\main.h

#define  C_FONTNAME		_FONTNAME
#define  C_FONTSIZE		8


*/////////////////////////////////////////////////////////////////
*// 				Base classes defines 
*/////////////////////////////////////////////////////////////////


*:********************************************************************
*:
*:    Class : STATUSBARVIEW based on VIEW
*:
*:********************************************************************
Define Class StatusBarView as View
	
	add object StatusBar as StatusBar
	
	*:********************************************************************
	*:
	*: Method : ACTIVATE of class STATUSBARVIEW
	*:
	*:********************************************************************
	Procedure Activate
	ActivateForm(this)
	
	*:********************************************************************
	*:
	*: Method : DEACTIVATE of class STATUSBARVIEW
	*:
	*:********************************************************************
	Procedure Deactivate
	DeActivateForm()
	
	*:********************************************************************
	*:
	*: Method : RESIZE of class STATUSBARVIEW
	*:
	*:********************************************************************
	PROCEDURE Resize
	With This
		.LockScreen=.T.
*!*			.Grid.Height=.Height-.StatusBar.height-.Grid.Top+2
*!*			.Grid.Width=.Width-.Grid.Left+2
		.Grid.ReSize()
		.StatusBar.Resize()
		if .SaveViewOnResize
			.SaveView()
		endif
		.LockScreen=.F.
	EndWith
	ENDPROC
	
EndDefine

*:********************************************************************
*:
*:    Class : MYVIEW based on VIEW
*:
*:********************************************************************
Define class MyView as View
	
	*:********************************************************************
	*:
	*: Method : KEYPRESS of class MYVIEW
	*:
	*:********************************************************************
	Procedure KeyPress( nKeyCode, nShiftAltCtrl)
	DoDefault(nKeyCode, nShiftAltCtrl)
	If nKeyCode=13 ;
			and nShiftAltCtrl=0 ;
			and ThisForm.WindowState # 1
		
		This.OpenOnEnter()
		
	endif
	
	*:********************************************************************
	*:
	*: Method : OPENONENTER of class MYVIEW
	*:
	*:********************************************************************
	Procedure OpenOnEnter
	with this
		if vartype(.ParentObject)='O'
			.ParentObject.Open()
		else
			if type('.parent')='O' and pemstatus(.parent,'open',5)
				.parent.open()
			else
				if vartype(ROOT_OBJECT)='O'
					ROOT_OBJECT.Open()
				endif
			endif
		endif			
	endwith	
EndDefine


* Default ViewForm class
*:********************************************************************
*:
*:    Class : VIEW based on FORM
*:
*:********************************************************************
Define class View as Form
	Protected View
	View=.T.
	
	Top = 0
	Left = 0
	ShowTips = .T.
	Caption = ""
	FontName = C_FONTNAME
	FontSize = C_FONTSIZE
	MDIForm = .T.
	Icon = _screen.icon
	
	*  
	
	Search = ""					&&  
	LastTime = 0				&&     
	Delay = 2					&&      
	Alias = ""
	Escaped = .T.				&&    ESCAPE
	Operations=0				&&     
	OperationClass=""			&&   
	SaveViewOnResize=.F.		&&       Resize
	ForceNormalView=.T.			&&     
	NoSaveView=.F.
	NoRestoreView=.F.
	KeyPreview=.T.
	ForceState=0
	CLSID=""
	ParentObject=.null.
	UnusedAlias=.F.
	
	MinWidth=100
	MinHeight=50
	
	ReportForm=""				&&   ,  ,    

	FaceMask=FACE_VIEW

	ActiveGrid=.null.
	
	ADD OBJECT grid AS MyGrid 
	
	ADD OBJECT Timer AS TIMER WITH ;
		Interval=0 
	
	*:********************************************************************
	*:
	*: Method : ACTIVATE of class VIEW
	*:
	*:********************************************************************
	Procedure Activate
	ActivateForm(this)
	
	*:********************************************************************
	*:
	*: Method : DEACTIVATE of class VIEW
	*:
	*:********************************************************************
	Procedure Deactivate
	DeactivateForm(this)
	
	*:********************************************************************
	*:
	*: Method : UNLOAD of class VIEW
	*:
	*:********************************************************************
	Procedure UnLoad
	with this
		if .UnusedAlias and Used(.Alias)
			use in (.Alias)
		endif
	endwith
	DeactivateForm(this)
	
	*:********************************************************************
	*:
	*: Method : SHOW of class VIEW
	*:
	*:********************************************************************
	Procedure Show(nStyle)
	if vartype(nStyle)='N' and nStyle=1
		this.MinButton=.F.
	endif
	DoDefault(nStyle)
	
	*:********************************************************************
	*:
	*: Method : SAVEVIEW of class VIEW
	*:
	*:********************************************************************
	Procedure SaveView
	with this
		SaveWindowPref(this)
		SaveListPref(.grid)
	endwith
	
	*:********************************************************************
	*:
	*: Method : RESTOREVIEW of class VIEW
	*:
	*:********************************************************************
	Procedure RestoreView
	with this
		ReadWindowPref(this)
		ReadListPref(.grid)
	endwith
	
	*:********************************************************************
	*:
	*: Method : KEYPRESS of class VIEW
	*:
	*:********************************************************************
	PROCEDURE KeyPress
	LPARAMETERS nKeyCode, nShiftAltCtrl
	with this
		if .Escaped and nKeyCode=27
			if .Close()
				NoDefault
				Return
			endif
		endif
		if nShiftAltCtrl=2 and Inlist(nKeyCode,30,31)
			if nKeyCode=31
				GO TOP
			else
				GO BOTTOM
			endif
		endif
	EndWith

	Procedure Close
	With this
		If .QueryUnLoad()
			.Hide
			.Release
		Else
			Return .F.
		EndIf
	EndWith

	
	*:********************************************************************
	*:
	*: Method : INIT of class VIEW
	*:
	*:********************************************************************
	PROCEDURE Init( lPrivate )
	*     
	*   ,   ,   
	*   
	with this
		m.lPrivate=!empty(m.lPrivate)
		if m.lPrivate
			.DataSession=2
		endif
	endwith
	
	*:********************************************************************
	*:
	*: Method : RESIZE of class VIEW
	*:
	*:********************************************************************
	PROCEDURE Resize
	With This
		.LockScreen=.T.
		.Grid.ReSize
		if .SaveViewOnResize
			.SaveView()
		endif
		.LockScreen=.F.
	EndWith
	ENDPROC
	
	*:********************************************************************
	*:
	*: Method : QUERYUNLOAD of class VIEW
	*:
	*:********************************************************************
	PROCEDURE QueryUnload
	With this
		.SaveView()
	EndWith 
	
	*:********************************************************************
	*:
	*: Method : TIMER.TIMER of class VIEW
	*:
	*:********************************************************************
	Procedure Timer.Timer
	* Timer events
	this.parent.grid.refresh
	
	*:********************************************************************
	*:
	*: Method : PRINT of class VIEW
	*:
	*:********************************************************************
	Procedure Print(nWhat)
	with this
		if Not Empty(.ReportForm)
			local o
			o=NewObject('PRINTCLASS','CLASSES.PRG')
			if vartype(o)=T_OBJECT
				o.FormFile=.ReportForm
				o.Title=.Caption
				o.Alias=.Grid.RecordSource
				Return o.Print(nWhat)			
			endif
		else
			if vartype(.ParentObject)='O'
				Return .ParentObject.Print(nWhat)
			else
				if type('.Parent')='O'
					Return .Parent.Print(nWhat)
				endif
			endif
			* Nothing to Print ?
		endif
	endwith
	
	*:********************************************************************
	*:
	*: Method : PREVIEW of class VIEW
	*:
	*:********************************************************************
	Procedure Preview(nWhat)
	Return This.Print(PRINT_PREVIEW)
	
	*:********************************************************************
	*:
	*: Method : PRINTMODIFY of class VIEW
	*:
	*:********************************************************************
	Procedure PrintModify(nWhat)
	Return This.Print(PRINT_MODIFY)
	
	*:********************************************************************
	*:
	*: Method : RIGHTCLICK of class VIEW
	*:
	*:********************************************************************
	Procedure RightClick(nColumn)
	with this
		if type('.parentobject')='O' ;
				and PEMSTATUS(.ParentObject,'ShortCutMenu',5)
			Return .ParentObject.ShortCutMenu(nColumn)
		else
			if type('.parent')='O' ;
					and PEMSTATUS(.Parent,'ShortCutMenu',5)
				Return .Parent.ShortCutMenu(nColumn)
			endif
		endif
		DoDefault()
	endwith
	
	*:********************************************************************
	*:
	*: Method : VERROR of class VIEW
	*:
	*:********************************************************************
	Procedure vError( nError, cMethod, nLine )
	if cMethod='SAVEVIEW' or cMethod='RESTOREVIEW'
		Return
	endif
	
	LogError( nError, cMethod, nLine )
	
	MessageBox(;
		"       ."+CR+;
		"  :"+Ltrim(Str(nError))+CR+;
		" :"+cMethod+CR+;
		" :"+MESSAGE();
		,16,"")
	

ENDDEFINE


*:********************************************************************
*:
*:    Class : MYGRID based on GRID
*:
*:********************************************************************
Define Class MyGrid as Grid 
	ColumnCount=0
	DeleteMark=.F.
	SplitBar=.F.
	AllowHeaderSizing=.F.
	AllowRowSizing=.F.
	FontName=C_FONTNAME
	FontSize=C_FONTSIZE
	Top=-1
	Left=-1
	NoReSize=.F.
	ClsID=""
	Summary=""
	
	*** VFP8 Properties
	
	HighlightBackColor=0
	HighlightForeColor=0	
	HighlightRowLineWidth=1
	HighlightRowLineWidth=0
	HighLightStyle=1
	AllowCellSelection=.T.
	
	*:********************************************************************
	*:
	*: Method : INIT of class MYGRID
	*:
	*:********************************************************************
	Procedure Init
	with this
		.GridLineColor=Thisform.BackColor
		.RowHeight=Fontmetric(1,.FontName,.FontSize)+2
		.HeaderHeight=Fontmetric(1,.FontName,.FontSize)+4
		.AllowCellSelection=.AllowCellSelection
	endwith

	Procedure AllowCellSelection_Assign(lVal)
	With this
		.AllowCellSelection=lVal
		If lVal
			.HighlightBackColor=thisform.backcolor
			.HighlightForeColor=thisform.forecolor
		Else
			.HighlightBackColor=GetSysColor(13)
			.HighlightForeColor=GetSysColor(14)
		EndIf
	EndWith

	
	*:********************************************************************
	*:
	*: Method : RESIZE of class MYGRID
	*:
	*:********************************************************************
	Procedure Resize
	with this
		if type('.parent')='O' and not .NoResize
			.Width=.Parent.Width+2
			if Vartype(.Parent.StatusBar)='O'
				.Height=.Parent.Height-.Parent.StatusBar.Height+2
				.Parent.StatusBar.ZOrder(0)
			else
				.Height=.Parent.Height+2
			endif
		endif
	endwith
	
	*:********************************************************************
	*:
	*: Method : ADDCOLUMN of class MYGRID
	*:
	*:********************************************************************
	Procedure AddColumn(nIndex, m.Field, m.Caption, m.InputMask, m.Tag)
	with this
		.AddObject("Column"+Ltrim(Str(nIndex)),"MyColumn",m.Field, m.Caption, m.InputMask, m.Tag)
		if vartype(m.InputMask)='N'
			.Columns[nIndex].SearchStyle=m.InputMask
		endif
		If not Empty(m.Tag) and Vartype(m.Tag)="N"
			.Columns[nIndex].Width=m.Tag
		EndIf
		.Columns[nIndex].Index=nIndex
		NoDefault
	endwith
	
	*:********************************************************************
	*:
	*: Method : RIGHTCLICK of class MYGRID
	*:
	*:********************************************************************
	Procedure RightClick(nColumn)
	this.Parent.RightClick(nColumn)

	Procedure When
	If PemStatus(Thisform,'ActiveGrid',5)
		thisform.ActiveGrid=this
	EndIf
	With this
		If .AllowCellSelection
			.HighlightBackColor=thisform.backcolor
			.HighlightForeColor=thisform.forecolor
		Else
			.HighlightBackColor=GetSysColor(13)
			.HighlightForeColor=GetSysColor(14)
		EndIf
	EndWith

	Procedure Valid
	With this
		.HighlightBackColor=thisform.backcolor
		.HighlightForeColor=thisform.forecolor
	EndWith

EndDefine


*:********************************************************************
*:
*:    Class : MYCOLUMN based on COLUMN
*:
*:********************************************************************
Define Class MyColumn as Column
	FontName=C_FONTNAME
	FontSize=C_FONTSIZE
	
	FieldName=""
	HotHeader=.F.
	HotSearch=.F.
	Visible=.T.
	Index=0

	SearchStyle=0
		
	Procedure SearchStyle_Assign(nNewVal)
	With this
		If Vartype(nNewVal)="N"
			If Vartype(.Text)="O"
				.Text.SearchStyle=nNewVal
				.SearchStyle=nNewVal
			EndIf
		EndIf
	EndWith
	
	*:********************************************************************
	*:
	*: Method : TAG_ASSIGN of class MYCOLUMN
	*:
	*:********************************************************************
	Procedure Tag_Assign(cTag)
	with this
		.Tag=cTag
		.Header.HotHeader=not empty(cTag)
	endwith
	
	*:********************************************************************
	*:
	*: Method : INIT of class MYCOLUMN
	*:
	*:********************************************************************
	Procedure Init( m.Field, m.Caption, m.InputMask, m.Tag )
	with this
		.RemoveObject('Header1')
		.AddObject("Header","MyHeader")
		.RemoveObject("Text1")
		.AddObject("Text","MyGridText")
		.CurrentControl="Text"
		.Text.Visible=.T.
		
		if not empty(m.Field)
			.ControlSource=(m.Field)
		endif
		if not empty(m.Caption)
			.Header.Caption=m.Caption
		else
			.Header.Caption=m.Field
		endif
		if not empty(m.InputMask) and vartype(m.InputMask)='C'
			.InputMask=m.InputMask
		endif
		if not empty(m.Tag) and vartype(m.Tag)='C'
			.Tag=m.Tag
		endif
		If Tagno(m.Field,.Parent.RecordSource)>0
			.Tag=m.Field
		EndIf
	EndWith 
	
	*:********************************************************************
	*:
	*: Method : RIGHTCLICK of class MYCOLUMN
	*:
	*:********************************************************************
	Procedure RightClick
	With this
		.Parent.RightClick(.Index)
	EndWith

	
EndDefine

*:********************************************************************
*:
*:    Class : MYHEADER based on HEADER
*:
*:********************************************************************
Define Class MyHeader as Header
	FontName=C_FONTNAME
	FontSize=C_FONTSIZE
	Alignment=2
	
	HotHeader=.F.
	XCoord=0
	YCoord=0

	SortOrder=0
	
	*:********************************************************************
	*:
	*: Method : MOUSEUP of class MYHEADER
	*:
	*:********************************************************************
	Procedure MouseUp( nButton, Shift, nXCoord, nYCoord )
	this.XCoord=nXCoord
	this.YCoord=nYCoord
	
	*:********************************************************************
	*:
	*: Method : CLICK of class MYHEADER
	*:
	*:********************************************************************
	Procedure Click
	with this

		If not Empty(.Parent.Tag)
		
			local m.Alias, m.FieldName, m.Tag, m.Rc, n, m.WhereOut
			.Parent.Parent.GridHitTest(.XCoord,.YCoord,@WhereOut)
			
			if inList(m.WhereOut,2,13)
				* Between Columns or Column Resize area
				Return .F.
			endif

			If Descending()
				.ShowOrder(1)
			Else
				.ShowOrder(2)
			EndIf
		EndIf
	EndWith 
	
	*:********************************************************************
	*:
	*: Method : RIGHTCLICK of class MYHEADER
	*:
	*:********************************************************************
	Procedure RightClick
	With this
		If not Empty(.parent.tag)
			Local m.name
			m.name=thisform.name
			
			Define Popup HeaderRightClick from Mrow(m.name),Mcol(m.name) shortcut margin relative 
			Define Bar 1 of HeaderRightClick Prompt ' '
			Define Bar 2 of HeaderRightClick Prompt '\-'
			Define Bar 3 of HeaderRightClick Prompt ' ' picture 'bin\images\tools\sort1.bmp'
			Define Bar 4 of HeaderRightClick Prompt ' ' picture 'bin\images\tools\sort2.bmp'
			
			If Version(5)>700
				Define Bar 5 of HeaderRightClick Prompt '\-'
				Define Bar 6 of HeaderRightClick Prompt ' '
				
			EndIf 
			
			On selection popup HeaderRightClick Deactivate Popup
			Activate Popup HeaderRightClick
			nBar=Bar()
			Release Popup HeaderRightClick
			
			DO case
			Case nBar=1
				.ShowOrder(0)
			Case nBar=3
				.ShowOrder(1)
			Case nBar=4
				.ShowOrder(2)
			Case nBar=6
				.parent.parent.AutoFit()
			EndCase

		EndIf
	EndWith
	
	*:********************************************************************
	*:
	*: Method : SHOWORDER of class MYHEADER
	*:
	*:********************************************************************
	Procedure ShowOrder(nOrder)
	With this
		Local m.rc,o
		m.Rc=Recno()
		
		ThisForm.LockScreen=.T.
		
		.parent.parent.SetAll("FontBold",.F.,.Class)
		.parent.parent.SetAll("ForeColor",thisform.forecolor,.Class)

		For each o in .parent.parent.columns
			o.Header.FontBold=.F.
			o.Header.ForeColor=thisform.forecolor
		Next

		
		IF PEMSTATUS(this,'Picture',5)
			.parent.parent.SetAll("Picture","",.Class)
		ENDIF 

		DO Case
		Case nOrder<1
			.SortOrder=0
			Set Order To tag 0
			IF PEMSTATUS(this,'Picture',5)
				.Picture=""
			ENDIF 
		Case nOrder=1
			.SortOrder=1
			Set Order To Tag (.Parent.Tag) ascending
			.FontBold=.T.
			.forecolor=rgb(0,0,128)		
			IF PEMSTATUS(this,'Picture',5)
				.Picture="Bin\Images\Tools\Sort01.bmp"
			ENDIF 
		Case nOrder=2
			.SortOrder=2
			Set Order To Tag (.Parent.Tag) descending
			.FontBold=.T.
			.forecolor=rgb(128,0,0)		
			IF PEMSTATUS(this,'Picture',5)
				.Picture="Bin\Images\Tools\Sort02.bmp"
			ENDIF 
		EndCase
		if between(m.rc,1,Reccount())
			go m.rc
		endif
		.parent.parent.refresh
		
		ThisForm.LockScreen=.F.
	EndWith
	
EndDefine

*:********************************************************************
*:
*:    Class : MYGRIDTEXT based on TEXTBOX
*:
*:********************************************************************
Define Class MyGridText as TextBox 
	FontName=C_FONTNAME
	FontSize=C_FONTSIZE
	
	Margin=0
	SpecialEffect=1
	SelectOnEntry=.T.
	BorderStyle=0
	Visible=.T.
	
	SearchStyle=0
	Timer=0
	Delay=2
	
	ChangesNotify=.T.
	
	tmpVal=.null.
	
	WhenProcedure=""
	ValidProcedure=""
	
	*:********************************************************************
	*:
	*: Method : INTERACTIVECHANGE of class MYGRIDTEXT
	*:
	*:********************************************************************
	Procedure InteractiveChange
	with this
		if .ChangesNotify ;
				and Type('thisform.app')='O' ;
				and PEMStatus(thisform.app,'changes',5)
			
			thisform.app.changes=.t.
			
		endif	
	endwith
	
	*:********************************************************************
	*:
	*: Method : WHEN of class MYGRIDTEXT
	*:
	*:********************************************************************
	Procedure When
	with this
		.TmpVal=.Value
		if not empty(.WhenProcedure)
			go Recno()
			Return eval(.WhenProcedure)
		endif
	endwith
	
	*:********************************************************************
	*:
	*: Method : VALID of class MYGRIDTEXT
	*:
	*:********************************************************************
	Procedure Valid
	with this
		if .tmpval # .value and not empty(.ValidProcedure)
			go Recno()	&& Flush current record
			Return eval(.ValidProcedure)
		endif
	endwith	
	
	*:********************************************************************
	*:
	*: Method : KEYPRESS of class MYGRIDTEXT
	*:
	*:********************************************************************
	Procedure KeyPress(nKeyCode, nShiftAltCtrl )
	with this
		If InList(Vartype(.Value),"N","Y") and InList(nKeyCode,Asc('.'),Asc(','),Asc("-"))
			DoDefault(Asc(Set("Point")),nShiftAltCtrl)
		EndIf
		if .SearchStyle<1
			*			DoDefault(nKeyCode, nShiftAltCtrl)
		else
			if nShiftAltCtrl < 2 ;
					and (between(nKeyCode,32,126) or between(nKeyCode,192,255))
				
				if Seconds()-.Timer > .Delay
					.Tag=""
				endif
				
				local m.Alias, m.FieldName, m.tag, m.char, rc
				m.char=chr(nKeyCode)
				m.Alias=.parent.parent.RecordSource
				if not empty(.parent.FieldName)
					m.FieldName=.parent.FieldName
				else
					m.FieldName=.parent.ControlSource
				endif
				if tagno(m.FieldName,m.Alias)>0
					m.tag=m.FieldName
				else
					if not empty(.parent.tag)
						m.tag=.parent.tag
					else
						if .SearchStyle=1
							.SearchStyle=2
						endif
					endif
				endif
				
				rc=Recno(m.Alias)
				set message to " :"+.tag+m.char
				
				do case
				case .SearchStyle=1		&& Search By Seek
					seek upper(.tag+m.char) order tag (m.tag) in (m.alias)
					
				case .SearchStyle=2		&& Search By Direct Locate 
					locate for upper(&FieldName)=upper(.tag+m.char)
					
				case .SearchStyle=3		&& Search by Random Locate
					locate for atc(.tag+m.char,&FieldName) > 0
					
				endcase
				if found()
					.tag=.tag+m.char
				else
					if between(rc,1,reccount(m.alias))
						go rc in (m.alias)
					endif
				endif
				.Timer=Seconds()
			else
				.tag=""
			endif
		endif
	endwith
	
	*:********************************************************************
	*:
	*: Method : GOTFOCUS of class MYGRIDTEXT
	*:
	*:********************************************************************
	Procedure GotFocus
	with this
		if vartype(ThisForm.StatusBar)='O'
			*			.Comment=ThisForm.StatusBar.Panels[1].Text.Caption
			*			ThisForm.StatusBar.Panels[1].Text.Caption=.StatusBarText
		else
			set message to .StatusBarText
		endif
	endwith
	
	*:********************************************************************
	*:
	*: Method : LOSTFOCUS of class MYGRIDTEXT
	*:
	*:********************************************************************
	Procedure LostFocus
	with this
		if vartype(ThisForm.StatusBar)='O'
			*			ThisForm.StatusBar.Panels[1].Text.Caption=.Comment
		else
			set message to ' '
		endif
	endwith
	
	*:********************************************************************
	*:
	*: Method : RIGHTCLICK of class MYGRIDTEXT
	*:
	*:********************************************************************
	Procedure RightClick
	this.parent.RightClick()
	
EndDefine

*: End of VIEW.PRG
