*:********************************************************************
*:
*: Procedure file :kernel.prg
*:
*: Contents :
*: 
*: 		Class     Kernel AS Custom HIDDEN
*: 
*: 		Class     Events AS Custom
*: 
*: 		Class     who AS Form
*: 
*: 		Class     OleList AS ListView
*:
*: (c) Piva, BEAR v.43 on 25.04.2003 12:37
*:********************************************************************
*
*       
*

#include main.h
*

*:********************************************************************
*:
*:    Class : Kernel based on Custom
*:
*:********************************************************************
Define Class Kernel As Custom
	
	*	Protected SelectedID
	SelectedID=0
	DocumentCount = 0
	Operation = 0
	Dimension Document[1]
	
	
	*-- Clears the contents of a ComboBox or ListBox control.
	*:********************************************************************
	*:
	*: Method : Clear of class Kernel
	*:
	*:********************************************************************
	Procedure Clear
	Local o, Name
	For Each o In This.Document
		If Vartype(o)=T_OBJECT
			Name=o.Name
			This.RemoveObject(o.Name)
		Endif
	Next
	This.DocumentCount=0
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : Reg of class Kernel
	*:
	*:********************************************************************
	Procedure Reg
	* Register documents
	Lparameter oDoc
	Local i
	With This
		If Vartype(oDoc)=T_OBJECT
			.DocumentCount=.DocumentCount+1
			Dimension .Document[.DocumentCount]
			.Document[.DocumentCount]=oDoc
		Endif
	Endwith
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : New of class Kernel
	*:
	*:********************************************************************
	Procedure New
	* Interface functons such as NEW, OPEN, DELETE etc
	Lparameter cDocument, xDummy
	Return This.Shell(OP_NEW,cDocument, xDummy)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : Open of class Kernel
	*:
	*:********************************************************************
	Procedure Open
	Lparameter cDocument, xDummy
	Return This.Shell(OP_OPEN,cDocument, xDummy)
	Endproc
	
	
	*-- Delete Event.
	*:********************************************************************
	*:
	*: Method : Delete of class Kernel
	*:
	*:********************************************************************
	Procedure Delete
	Lparameter cDocument, xDummy
	Return This.Shell(OP_DELETE,cDocument, xDummy)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : Close of class Kernel
	*:
	*:********************************************************************
	Procedure Close
	Lparameter cDocument, xDummy
	Return This.Shell(OP_CLOSE,cDocument, xDummy)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : List of class Kernel
	*:
	*:********************************************************************
	Procedure List
	Lparameter cDocument, xDummy
	Return This.Shell(OP_LIST,cDocument, xDummy)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : Print of class Kernel
	*:
	*:********************************************************************
	Procedure Print
	Lparameter cDocument, xDummy
	Return This.Shell(OP_PRINT,cDocument, xDummy)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : Preview of class Kernel
	*:
	*:********************************************************************
	Procedure Preview
	Lparameter cDocument, xDummy
	Return This.Shell(OP_PREVIEW,cDocument, xDummy)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : PrintModify of class Kernel
	*:
	*:********************************************************************
	Procedure PrintModify
	Lparameter cDocument, xDummy
	Return This.Shell(OP_PRINTMODIFY,cDocument, xDummy)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : PrintForm of class Kernel
	*:
	*:********************************************************************
	Procedure PrintForm
	Lparameter cDocument, xDummy
	Return This.Shell(OP_PRINTFORM,cDocument, xDummy)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : PrintSetup of class Kernel
	*:
	*:********************************************************************
	Procedure PrintSetup
	Lparameter cDocument, xDummy
	Sys(1037)
	
	*	RETURN This.Shell(OP_PRINTSETUP,cDocument, xDummy)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : PrinterSelect of class Kernel
	*:
	*:********************************************************************
	Procedure PrinterSelect
	Local cName
	cName=Getprinter()
	If !Empty(cName)
		Set Printer To Name cName
	Endif
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : Create of class Kernel
	*:
	*:********************************************************************
	Procedure Create
	Lparameter cDocument, xDummy
	Return This.Shell(OP_CREATE,cDocument, xDummy)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : Load of class Kernel
	*:
	*:********************************************************************
	Procedure Load
	Lparameter cDocument, xDummy
	Return This.Shell(OP_LOAD,cDocument, xDummy)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : Save of class Kernel
	*:
	*:********************************************************************
	Procedure Save
	Lparameter cDocument, xDummy
	Return This.Shell(OP_SAVE,cDocument, xDummy)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : Find of class Kernel
	*:
	*:********************************************************************
	Procedure Find
	Lparameter cDocument, xDummy
	Return This.Shell(OP_FIND,cDocument, xDummy)
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : Shell of class Kernel
	*:
	*:********************************************************************
	Procedure Shell
	Lparameters nAction, xDocument, xDummy
	If Vartype(nAction) # T_NUMERIC
		Messagebox(ERR_INVLAID_CODE_TYPE,48,_Screen.Caption)
		Return .F.
	Endif
	Local oDoc, cMethod, cDescription, lFlag, lSkipTop
	oDoc=.Null.
	cMethod=""
	lFlag=.F.
	lSkipTop=.F.
	If Empty(xDocument)
		xDocument=""
	Endif
	
	This.Operation=nAction
	
	Do Case
	Case Vartype(xDocument)=T_OBJECT
		*      
		oDoc=xDocument
	Case Vartype(xDocument)=T_NUMERIC
		*      
		If Between(xDocument,1,This.DocumentCount) ;
				and Vartype(This.Document[xDocument])=T_OBJECT
			
			oDoc=This.Document[xDocument]
			
		Endif
		
	Case Vartype(xDocument)=T_CHARACTER
		*  
		For Each oDoc In This.Document
			If Vartype(oDoc)=T_OBJECT And Upper(oDoc.Name)==Upper(xDocument)
				lFlag=.T.
				Exit
			Endif
		Next
		If Not lFlag
			oDoc=.Null.
		Endif
	Other
		Messagebox(ERR_INVALID_DOCUMENT,48,_Screen.Caption)
		Return .F.
	Endcase
	Do Case
	Case nAction=OP_NEW
		cMethod="NEW"
		cDescription=""
	Case nAction=OP_OPEN
		cMethod="OPEN"
		cDescription=""
	Case nAction=OP_DELETE
		cMethod="DELETE"
		cDescription=""
	Case nAction=OP_CLOSE
		cMethod="CLOSE"
		cDescription=""
		
	Case nAction=OP_LIST
		cMethod="LIST"
		cDescription=" "
		lSkipTop=.T.
	Case nAction=OP_PRINT
		cMethod="PRINT"
		cDescription=""
	Case nAction=OP_PRINTSETUP
		cMethod="PRINTSETUP"
		cDescription=" "
		Return This.PrintSetup()
	Case nAction=OP_PREVIEW
		cMethod="PREVIEW"
		cDescription=" "
	Case nAction=OP_PRINTMODIFY
		cMethod="PRINTMODIFY"
		cDescription="  "
	Case nAction=OP_PRINTFORM
		cMethod="PRINTFORM"
		cDescription=" "
	Case nAction=OP_PRINTLIST
		cMethod="PRINTLIST"
		cDescription=" "
		
	Case nAction=OP_CREATE
		cMethod="CREATE"
		cDescription="  "
	Case nAction=OP_LOAD
		cMethod="LOAD"
		cDescription="  "
	Case nAction=OP_SAVE
		cMethod="SAVE"
		cDescription="  "
		
	Case nAction=OP_FIND
		cMethod="FIND"
		cDescription=""
		lSkipTop=.T.
		
	Case nAction=OP_QUIT
		This.Shutdown()
		Return .T.
	Other
		If Vartype(This.Events)=T_OBJECT
			If This.Events.GetEvent(nAction, @cMethod, @cDescription,@lSkipTop)
				*  Nothing ?
			Endif
		Endif
		If Empty(cMethod)
			Messagebox(ERR_INVALID_OPCODE,48,_Screen.Caption)
			Return .F.
		Endif
	Endcase
	
	If Vartype(oDoc) # T_OBJECT
		oDoc=This.Look4Document()
	Endif
	
	If (lSkipTop) Or (Vartype(oDoc) # T_OBJECT)
		Local iDoc
		iDoc=0
		This.SelectedID=0
		This.Newobject("WHO","WHO","",CLASS_APP,cMethod, cDescription)
		If Vartype(This.who)='O'
			This.who.Show(1)
		Endif
		If Vartype(This.SelectedID)='N' And Not Empty(This.SelectedID)
		Else
			Return .F.
		Endif
		oDoc=This.Document[This.SelectedID]
	Endif
	
	Local m.cProcName
	m.cProcName=Getwordnum(cMethod,1,'[]()')
	
	If PEMStatus(oDoc,cProcName,5) ;
			and Inlist(PEMStatus(oDoc,cProcName,3),'Event','Method')
		
		If cProcName=cMethod
			cMethod=cMethod+'()'
		Endif
		
		*       
		Return Eval('oDoc.'+cMethod)
	Else
		Messagebox(ERR_UNSUPPORTED_OPCODE,48,oDoc.Title)
	Endif
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : Look4Document of class Kernel - HIDDEN
	*:
	*:********************************************************************
	Hidden Procedure Look4Document
	*
	*      
	*
	Local oObj, o
	oObj=.Null.
	
	
	If Type("_SCREEN.ACTIVEFORM")=T_OBJECT ;
			and _Screen.ActiveForm.WindowState # WINDOWSTATE_MINIMIZED
		*  -  , ..      
		*    PARENT     
		* -       
		* -  .PARENTOBJECT   
		*      ...
		If Type("_SCREEN.ACTIVEFORM.PARENTOBJECT")=T_OBJECT
			oObj=_Screen.ActiveForm.PARENTOBJECT
		Else
			If Type('_SCREEN.ACTIVEFORM.PARENT')=T_OBJECT
				oObj=_Screen.ActiveForm.Parent
			Endif
		Endif
	Else
		*      -   BROWSE   
		*  API  - _WOPEN
		*        
		*      -    -   
		*    -   - 10     - 
		
		If !Empty(Wontop())
			For Each o In This.Document
				*         MyWindow,   ...
				If Vartype(o)=T_OBJECT And PEMStatus(o,'MyWindow',5)
					If Eval('o.myWindow(wontop())')
						oObj=o
						Exit
					Endif
				Endif
			Next
		Endif
	Endif
	Return oObj
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : IsDocument of class Kernel
	*:
	*:********************************************************************
	Procedure IsDocument
	Lparameter cDocumentName
	Local o
	With This
		For Each o In .Document
			If Vartype(o)=T_OBJECT
				If o.Name=cDocumentName
					Return .T.
				Endif
			Endif
		Next
	Endwith
	Return .F.
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : RefDocumentName of class Kernel
	*:
	*:********************************************************************
	Procedure RefDocumentName
	Lparameter cDocumentName
	Local o
	With This
		For Each o In .Document
			If Vartype(o)=T_OBJECT
				If o.Name=cDocumentName
					Return (o)
				Endif
			Endif
		Next
	Endwith
	Return .Null.
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : RefDocumentCLSID of class Kernel
	*:
	*:********************************************************************
	Procedure RefDocumentCLSID
	Lparameter cDocumentCLSID
	Local o
	With This
		For Each o In .Document
			If Vartype(o)=T_OBJECT
				If o.CLSID=cDocumentCLSID
					Return (o)
				Endif
			Endif
		Next
	Endwith
	Return .Null.
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : vError of class Kernel
	*:
	*:********************************************************************
	Procedure vError
	Lparameters nError, cMethod, nLine
	Local m.sys2018, k
	m.sys2018=Sys(2018)
	If Vartype(m.sys2018)#'C'
		m.sys2018=""
	Endif
	Logerror(nError, cMethod, nLine)
	Do Case
	Case Inlist(nError,108,1705)
		If Messagebox(fString(MSG_FILELOCKED,m.sys2018),2+48,BOX_ERROR)=4
			Retry
		Else
			Return
		Endif
	Case Inlist(nError,109,130)
		If Messagebox(MSG_RECORDLOCKED,2+48,BOX_ERROR)=4
			Retry
		Else
			Return
		Endif
	Other
		k=Messagebox(MSG_RUNTIME_ERROR,2+16,BOX_ERROR+" # "+Tran(nError,"@B 99999"))
		Do Case
		Case k=3
			Do CleanUp In Main
		Case k=4
			Retry
		Case k=5
			Return
		Endcase
	Endcase
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : Init of class Kernel
	*:
	*:********************************************************************
	Procedure Init
	With This
		.Newobject('Events','Events','',CLASS_APP)
		If Vartype(.Events)= T_OBJECT
			.Events.Load()
		Else
			Messagebox(MSG_EVENTFAIL,16,BOX_WARNING)
		Endif
		
	Endwith
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : Destroy of class Kernel
	*:
	*:********************************************************************
	Procedure Destroy
	This.Clear()
*	Pop Menu _Msysmenu To Master
	Endproc
	
	
	*-- * PlugIn New documents
	*:********************************************************************
	*:
	*: Method : PlugIn of class Kernel
	*:
	*:********************************************************************
	Procedure PlugIn
	Do PlugIn With This
	Endproc
	
	
	*:********************************************************************
	*:
	*: Method : StartUp of class Kernel
	*:
	*:********************************************************************
	Procedure StartUp
	This.PlugIn()
	
	*:********************************************************************
	*:
	*: Method : Shutdown of class Kernel
	*:
	*:********************************************************************
	Procedure Shutdown(lNoAsk)
	With This
		lNoAsk=Not Empty(lNoAsk)
		If Not lNoAsk
			If Messagebox(MSG_SHUTDOWN,4+32,_Screen.Caption) # 6
				Return .F.
			Endif
		Endif
		Release This
		Clear Events
	Endwith
	
Enddefine

*:********************************************************************
*:
*:    Class : Events based on Custom
*:
*:********************************************************************
Define Class Events As Custom
	LocalEvents = .F.
	
	*--  
	Dimension Events[1,EVENT_WIDE]
	
	*--   
	*:********************************************************************
	*:
	*: Method : Add of class Events
	*:
	*:********************************************************************
	Procedure Add
	*    
	*
	Lparameter m.nOpCode, m.cMethod, m.cDescription, m.lSkipTop
	If Vartype(m.nOpCode)='N' ;
			and !Empty(m.nOpCode) ;
			and !Empty(m.cMethod)
		
		With This
			
			Local i
			i=Ascan(.Events,m.nOpCode)
			If i>0
				*      
				Return .F.
			Endif
			i=Alen(.Events,1)+1
			Dimension .Events[i,EVENT_WIDE]
			.Events[i,1]=m.nOpCode
			.Events[i,2]=m.cMethod
			.Events[i,3]=Iif(Vartype(m.cDesciption)='C',m.cDescription,"")
			.Events[i,4]=m.lSkipTop
			
		Endwith
		
	Endif
	Endproc
	
	
	*--  
	*:********************************************************************
	*:
	*: Method : Remove of class Events
	*:
	*:********************************************************************
	Procedure Remove
	Lparameter m.xWhat
	Local i, j, m.nRemove
	m.nRemove=0
	With This
		If Vartype(m.xWhat)='C'
			* 
			
			For i=1 To Alen(.Events,1)
				If Upper(m.xWhat)=Upper(.Events[i,2])
					m.nRemove=i
					Exit
				Endif
			Next
		Endif
		If Vartype(m.xWhat)='N'
			i=Ascan(.Events,m.xWhat)
			If i > 0
				m.nRemove=Asub(.Events,i,1)
			Endif
		Endif
		If m.nRemove > 0
			.Events[m.nRemove,1]=0
			.Events[m.nRemove,2]=""
			.Events[m.nRemove,3]=""
			.Events[m.nRemove,4]=.F.
			
			If Alen(.Events,1) > 1
				Adel(.Events,m.nRemove)
				i=Alen(.Events,1)-1
				Dimension .Events[i,EVENT_WIDE]
			Endif
		Endif
	Endwith
	Endproc
	
	
	*--   
	*:********************************************************************
	*:
	*: Method : Clear of class Events
	*:
	*:********************************************************************
	Procedure Clear
	*   
	*
	With This
		Dimension .Events[1,EVENT_WIDE]
		.Events[1,1]=0
		.Events[1,2]=""
		.Events[1,3]=""
		.Events[1,4]=.F.
	Endwith
	Endproc
	
	
	*--  
	*:********************************************************************
	*:
	*: Method : Load of class Events
	*:
	*:********************************************************************
	Procedure Load
	*    
	*     /
	*
	* 04.10.1999 01:10
	*   .. 1999
	*
	*  :
	*	_=
	*        
	*   
	*
	
	Local acts[1], i, k, s
	Dimension acts[1]
	
	With This
		.Clear()
		If .LocalEvents
			GetLocalSection( @acts, 'Events')
		Else
			GetGlobalSection( @acts, 'Events')
		Endif
		k=0
		For i=1 To Alen(acts,1)
			If Vartype(acts[i])='C'
				If .LocalEvents
					s=GetLocalProfile( 'Events',acts[i],'')
				Else
					s=GetGlobalProfile( 'Events',acts[i],'')
				Endif
				If Not Empty(s) ;
						and Val(acts[i]) # 0 ;
						and !Empty(Getwordnum(s,1,';'))
					
					k=k+1
					Dimension .Events[k,EVENT_WIDE]
					.Events[k,1]=Val(acts[i])		&& Operation code
					.Events[k,2]=Getwordnum(s,1,';')	&& Event Name
					.Events[k,3]=Getwordnum(s,2,';')	&& Event description
					.Events[k,4]=Inlist(Upper(Getwordnum(s,3,';')),'ON','YES','TRUE')
				Endif
			Endif
		Next
	Endwith
	Endproc
	
	*:********************************************************************
	*:
	*: Method : GetEvent of class Events
	*:
	*:********************************************************************
	Procedure GetEvent
	*       m.nOpCode
	* m.RefXXXXXXXX   
	*
	
	Lparameter m.nOpCode, m.RefMethod, m.RefDescr, m.RefSkipTop
	If Vartype(m.nOpCode)='N' And !Empty(m.nOpCode)
		With This
			Local i, j
			i=Ascan(.Events, m.nOpCode)
			If i > 0
				j=Asub(.Events,i,1)
				If !Empty(.Events[j,2])
					m.RefMethod=.Events[j,2]
					m.RefDescr=.Events[j,3]
					m.RefSkipTop=.Events[j,4]
					Return .T.
				Endif
			Endif
		Endwith
	Endif
	Return .F.
	Endproc
	
Enddefine

*:********************************************************************
*:
*:    Class : who based on Form
*:
*:********************************************************************
Define Class who As Form
	AutoCenter=.T.
	Desktop=.T.
	MinButton=.F.
	MaxButton=.F.
	Width=375
	Height=375
	BorderStyle=2
	WindowType=1
	Icon=_Screen.Icon
	Caption=""
	
	Add Object Panel As Container With ;
		SpecialEffect=0
	
	Add Object Image As MyImage With ;
		Width=32,;
		Height=32,;
		Picture=BMP_WHO
	
	Add Object Label As MyLabel With ;
		Caption='    ';
	
	Add Object Shape As Shape With ;
		Height=2,;
		SpecialEffect=0
	
	Add Object List As OleList
	Add Object cmdOk As cmdOk
	Add Object cmdCancel As cmdCancel
	
	*:********************************************************************
	*:
	*: Method : Init of class who
	*:
	*:********************************************************************
	Procedure Init( m.cMethod, m.cDescription )
	Local o, i, k
	With This
		* Such as RESIZE
		.Panel.Left=5
		.Panel.Top=5
		.Panel.Width=.Width-10
		.Panel.Height=.Height-5-.cmdCancel.Height-10
		.Image.Left=.Panel.Left+10
		.Image.Top=.Panel.Top+10
		.Label.Left=.Image.Left+.Image.Width+10
		.Label.Top=.Panel.Top+10
		.Label.Height=45
		.Label.Width=.Panel.Width-.Label.Left-5
		.Shape.Top=.Label.Top+.Label.Height+5
		.Shape.Left=.Panel.Left+5
		.Shape.Width=.Panel.Width-.Shape.Left-5
		.List.Left=.Panel.Left+10
		.List.Top=.Shape.Top+10
		.List.Width=.Panel.Width-.List.Left-10
		.List.Height=.Panel.Height-.List.Top-10
		
		.List.ColumnHeaders(1).Width=(.List.Width-Sysmetric(5)-5)*_ASPECT
		
		.cmdCancel.Top=.Height-.cmdCancel.Height-5
		.cmdCancel.Left=.Width-.cmdCancel.Width-5
		.cmdOk.Top=.cmdCancel.Top
		.cmdOk.Left=.cmdCancel.Left-.cmdOk.Width-5
		
		.Caption=cDescription
		.Label.Caption='    "'+.Caption+;
			'"    ""    .'
		
		.Parent.SelectedID=0
		k=0
		For i=1 To Alen(.Parent.Document,1)
			o=.Parent.Document[i]
			If Vartype(o)=T_OBJECT ;
					and PEMStatus(o,cMethod,5);
					and Vartype(o.Title)='C';
					and Not Empty(o.Title) ;
					and o.Grant(.Parent.Operation)
				
				k=k+1
				.List.ListItems.Add(,Tran(i,'@0'),Ltrim(Str(k))+'. '+Alltrim(o.Title))
			Endif
		Next
		
		If k=0
			Messagebox([    "]+cDescription+[" .],48,.Caption)
			Return .F.
		Endif
		If k=1
			.Parent.SelectedID=Val(.List.SelectedItem.Key)
			Return .F.
		Endif
		Aspect(this)
		.Visible=.T.
	Endwith

	
	*:********************************************************************
	*:
	*: Method : Activate of class who
	*:
	*:********************************************************************
	Procedure Activate
	ActivateForm(This)
	
	*:********************************************************************
	*:
	*: Method : cmdOk.Click of class who
	*:
	*:********************************************************************
	Procedure cmdOk.Click
	With Thisform
		*		.parent.SelectedID=.list.ListItemID
		.Parent.SelectedID=Val(.List.SelectedItem.Key)
		
		.Tag='OK'
		.Release()
	Endwith
	
	*:********************************************************************
	*:
	*: Method : List.DblClick of class who
	*:
	*:********************************************************************
	Procedure List.DblClick
	Thisform.cmdOk.Click()
	
	
	*:********************************************************************
	*:
	*: Method : Unload of class who
	*:
	*:********************************************************************
	Procedure Unload
	DeactivateForm(this)
	
EndDefine 


*:********************************************************************
*:
*:    Class : OleList based on ListView
*:
*:********************************************************************
Define Class OleList As ListView Of BaseCtrl.VCX
	
	*:********************************************************************
	*:
	*: Method : Init of class OleList
	*:
	*:********************************************************************
	Procedure Init
	With This
		DoDefault()
		
		.HideColumnHeaders=.T.
		.HideSelection=.F.
		
		.ColumnHeaders.Add(1,,' ',300)
		
	Endwith
	
	*:********************************************************************
	*:
	*: Method : KeyPress of class OleList
	*:
	*:********************************************************************
	Procedure KeyPress( Key )
	If Key=13
		Thisform.cmdOk.Click
	Endif
	If Key=27
		Thisform.cmdCancel.Click
	Endif

	Procedure GotFocus
	_Vfp.StatusBar="  "
	
EndDefine 

*: End of kernel.prg
