*:********************************************************************
*:
*: Procedure file :tools.prg
*:
*: Contents :
*: 
*: 		Class     ProgressForm AS form
*: 
*: 		Class     CancelButton AS commandbutton
*: 
*: 		Class     Info AS Form
*: 
*: 		Class     Wait AS Form
*: 
*: 		Class     Menu AS Custom
*:
*: (c) Piva, BEAR v.43 on 25.04.2003 09:46
*:********************************************************************
*
*    
*   .. 2000
* 18.04.2000 23:37
* 
*
*

#define MF_INSERT           0x00000000
#define MF_CHANGE           0x00000080
#define MF_APPEND           0x00000100
#define MF_DELETE           0x00000200
#define MF_REMOVE           0x00001000

#define MF_BYCOMMAND        0x00000000
#define MF_BYPOSITION       0x00000400

#define MF_SEPARATOR        0x00000800

#define MF_ENABLED          0x00000000
#define MF_GRAYED           0x00000001
#define MF_DISABLED         0x00000002

#define MF_UNCHECKED        0x00000000
#define MF_CHECKED          0x00000008
#define MF_USECHECKBITMAPS  0x00000200

#define MF_STRING           0x00000000
#define MF_BITMAP           0x00000004
#define MF_OWNERDRAW        0x00000100

#define MF_POPUP            0x00000010
#define MF_MENUBARBREAK     0x00000020
#define MF_MENUBREAK        0x00000040

#define MF_UNHILITE         0x00000000
#define MF_HILITE           0x00000080

#define TPM_LEFTBUTTON  	0x0000
#define TPM_RIGHTBUTTON 	0x0002
#define TPM_LEFTALIGN   	0x0000
#define TPM_CENTERALIGN 	0x0004
#define TPM_RIGHTALIGN  	0x0008
#define TPM_TOPALIGN        0x0000
#define TPM_VCENTERALIGN    0x0010
#define TPM_BOTTOMALIGN     0x0020

#define TPM_HORIZONTAL      0x0000  
#define TPM_VERTICAL        0x0040  
#define TPM_NONOTIFY        0x0080  
#define TPM_RETURNCMD       0x0100

#define WM_COMMAND			0x0111

xx=CreateObject("Menu")

With xx
	.Additem(1,"One")
	.Additem(2,"T\<wo")
	.Additem(3,"Three")
	
	.Additem(5,"Four")
	.Additem(6,"Fi&ve")
	.Additem(7,"&Six")
	
	.Show()
	
	? .Bar
	
EndWith


*:********************************************************************
*:
*:    Class : ProgressForm based on form
*:
*:********************************************************************
Define class ProgressForm as form
	AlwaysOnTop=.t.
	MinButton=.f.
	MaxButton=.f.
	Closable=.f.
	ControlBox=.f.
	BorderStyle=2
	AutoCenter=.t.
	Caption=' '
	Width=300
	Height=100
	DeskTop=.T.
	
	CancelButton=.F.
	Cancel=.F.
	Text=""
	Value=0
	
	add object label as label with ;
		fontname=_fontname,;
		fontsize=8,;
		alignment=2,;
		wordwrap=.t.,;
		top=5,;
		left=5,;
		width=290,;
		height=40,;
		caption=' ',;
		autosize=.f.		
	
	*:********************************************************************
	*:
	*: Method : Init of class ProgressForm
	*:
	*:********************************************************************
	Procedure Init( m.nValue, m.cText, m.cCaption, m.lCancelButton)
	with this
		.newobject('progress','progressbar','commctrl.prg')
		with .progress
			.top=70
			.left=10
			.width=this.width-21
			.height=20
			.visible=.t.
			*			.style=1
			.show()
		endwith
		
		if vartype(m.cText)='C'
			.text=m.cText
		endif
		if vartype(m.cCaption)='C'
			.caption=m.cCaption
		endif
		if not empty(m.lCancelButton)
			.CancelButton=.T.
		endif
	endwith
	
	*:********************************************************************
	*:
	*: Method : CancelButton_Assign of class ProgressForm
	*:
	*:********************************************************************
	Procedure CancelButton_Assign( NewVal )
	NewVal=!empty(NewVal)
	with this
		if NewVal
			.height=.height+30
			.addobject("cmdCancel","CancelButton")
			.cmdCancel.Top=.Height-24-5
			.cmdCancel.Left=(.Width-.cmdCancel.Width)/2
			.cmdCancel.Visible=.t.
		else
			if .height>300
				if vartype(cmdCancel)='O'
					.RemoveObject('cmdCancel')
				endif
				.Cancel=.F.
				.CancelButton=.F.
				.height=300
			endif
		endif
	endwith
	
	*:********************************************************************
	*:
	*: Method : text_assign of class ProgressForm
	*:
	*:********************************************************************
	Procedure text_assign( m.text )
	with this.label
		.top=5
		.left=5
		.width=290
		.height=40
		.caption=iif(vartype(m.text)="C",m.text,tran(m.text,""))
		*		.autosize=.t.
	endwith
	
	*:********************************************************************
	*:
	*: Method : value_assign of class ProgressForm
	*:
	*:********************************************************************
	Procedure value_assign( m.val )
	with this
		.progress.value(m.val)
	endwith
	
enddefine

*:********************************************************************
*:
*:    Class : CancelButton based on commandbutton
*:
*:********************************************************************
Define class CancelButton as commandbutton
	FontName=_FontName
	FontSize=8
	Caption='\<'
	Cancel=.t.
	Width=80
	Height=24
	
	*:********************************************************************
	*:
	*: Method : Click of class CancelButton
	*:
	*:********************************************************************
	Procedure Click
	thisform.cancel=.t.
	
enddefine

*:********************************************************************
*:
*:    Class : Info based on Form
*:
*:********************************************************************
Define class Info as Form 
	AlwaysOnTop=.t.
	MinButton=.f.
	MaxButton=.f.
	Closable=.f.
	ControlBox=.f.
	AutoCenter=.t.
	BorderStyle=2
	TitleBar=0
	Width=300
	Height=60
	Text=""
	DeskTop=.T.
	
	
	add object label as label with ;
		top=2,;
		left=2,;
		width=296,;
		height=56,;
		caption='',;
		fontname=_fontname,;
		fontsize=8,;
		alignment=2,;
		wordwrap=.t.,;
		backstyle=0,;
		autosize=.f.
	
	*:********************************************************************
	*:
	*: Method : Init of class Info
	*:
	*:********************************************************************
	Procedure Init( m.cText)
	with this
		if not empty(m.cText)
			.text=m.cText
		else
			.text="  ..."
		endif
	endwith
	
	*:********************************************************************
	*:
	*: Method : Text_Assign of class Info
	*:
	*:********************************************************************
	Procedure Text_Assign( m.cText )
	with this
		If PCount()=0
			This.Release
		endif
		
		if vartype(m.cText) = 'C'
			.text=m.cText
		else
			.text=alltrim(tran(m.cText,""))				
		endif
		with .label
			.autosize=.f.
			.left=2
			.top=2
			.width=296
			.height=56
			.caption=.parent.text
			.autosize=.t.
		endwith
	endwith
	
enddefine

*:********************************************************************
*:
*:    Class : Wait based on Form
*:
*:********************************************************************
Define class Wait as Form 
	AlwaysOnTop=.t.
	MinButton=.f.
	MaxButton=.f.
	Closable=.f.
	ControlBox=.f.
	AutoCenter=.t.
	BorderStyle=2
	TitleBar=0
	Width=300
	Height=60
	Text=""
	DeskTop=.T.
	
	
	add object label as label with ;
		top=2,;
		left=40,;
		width=236,;
		height=56,;
		caption='',;
		fontname=_fontname,;
		fontsize=8,;
		alignment=2,;
		wordwrap=.t.,;
		backstyle=0,;
		autosize=.f.,;
		Visible=.t.
	
	*:********************************************************************
	*:
	*: Method : Init of class Wait
	*:
	*:********************************************************************
	Procedure Init( m.cText)
	with this
		.NewObject("Avi","Animation","CommCtrl.PRG")
		With .Avi
			.Top=2
			.Left=2
			.Width=32
			.Height=32
			.Show()
			.Play("Bin\Images\Avi\1037.avi")
		EndWith
		
		
		if not empty(m.cText)
			.text=m.cText
		else
			.text="  ..."
		endif
		
	endwith
	
	*:********************************************************************
	*:
	*: Method : Text_Assign of class Wait
	*:
	*:********************************************************************
	Procedure Text_Assign( m.cText )
	with this
		If PCount()=0
			This.Release
		endif
		
		if vartype(m.cText) = 'C'
			.text=m.cText
		else
			.text=alltrim(tran(m.cText,""))				
		endif
		with .label
			.autosize=.f.
			.top=2
			.left=40
			.width=236
			.height=56
			.caption=.parent.text
			.autosize=.t.
		endwith
	endwith
	
enddefine


*:********************************************************************
*:
*:    Class : Menu based on Custom
*:
*:********************************************************************
Define Class Menu as Custom
	**  shortcutmenu
	
	hMenu=0		&& menu handle
	Style=TPM_LEFTBUTTON
	Bar=0
	
	*:********************************************************************
	*:
	*: Method : AddItem of class Menu
	*:
	*:********************************************************************
	Procedure AddItem(nIndex,cPrompt,lChecked,lDisable,nStyle)
	With this
		Local flag
		flag=0
		DO case
		Case InList(cPrompt,"-","\-")
			flag=MF_SEPARATOR
		Case InList(cPrompt,"|","\|")
			flag=MF_MENUBARBREAK
			cPrompt=SubStr(cPrompt,Atc("|",cPrompt)+1)
		Otherwise
		cPrompt=Strtran(cPrompt,'\<','&')
		flag=MF_STRING
	EndCase
	
	flag=flag+Iif(lChecked,MF_CHECKED,0)
	flag=flag+Iif(lDisable,MF_GRAYED,0)
	
	If Vartype(nStyle)='N'
		flag=flag+nStyle
	EndIf
	
	AppendMenu(.hMenu,flag,nIndex,cPrompt)
	
EndWith
	
	*:********************************************************************
	*:
	*: Method : Show of class Menu
	*:
	*:********************************************************************
	Procedure Show(Left,Top)
	With this
		Local buf, n
		
		.Top=Iif(Empty(Top),0,Top)
		.Left=Iif(Empty(Left),0,Left)
		
		If Empty(.Top) and Empty(.Left)
			buf=Space(8)
			GetCursorPos(@buf)
			.Left=.C2B(Substr(buf,1,4))
			.Top=.C2B(Substr(buf,5,4))
		EndIf 
		
		buf=Replicate(Chr(0),32)
		
		_VFP.AutoYield=.F.
		TrackPopupMenu(.hMenu,.Style,.Left,.Top,0,_VFP.hWnd,0)
		PeekMessage(@buf,_vfp.hwnd,WM_COMMAND,WM_COMMAND,1)
		_VFP.AutoYield=.T.
		
		.Bar=.C2B(Substr(buf,9,4))
		Return .Bar
		
	EndWith
	
	*:********************************************************************
	*:
	*: Method : Init of class Menu
	*:
	*:********************************************************************
	Procedure Init
	With this
		.LoadApi()
		.hMenu=CreatePopupMenu()
	EndWith
	
	*:********************************************************************
	*:
	*: Method : Destroy of class Menu
	*:
	*:********************************************************************
	Procedure Destroy
	With this 
		DestroyMenu(.hMenu)
	EndWith
	
	*:********************************************************************
	*:
	*: Method : LoadApi of class Menu
	*:
	*:********************************************************************
	Procedure LoadApi
	With this
		
		Declare integer CreatePopupMenu in Win32Api
		Declare integer AppendMenu in Win32Api ;
			integer hmenu,;
			integer flag,;
			integer UID,;
			string prompt
		
		Declare integer DestroyMenu in Win32Api integer hmenu	
		
		Declare integer TrackPopupMenu in Win32Api ;
			integer hMenu,;
			integer flags,;
			integer x,;
			integer y,;
			integer reserved,;
			integer hwnd,;
			string RECT
		
		Declare integer PeekMessage in Win32Api ;
			string @ lpMsg,;
			integer hWnd,;
			integer MinMSG,;
			integer MaxMSG,;
			integer Remove
		
		Declare integer GetCursorPos in Win32Api string @
		
	EndWith
	
	*:********************************************************************
	*:
	*: Method : C2B of class Menu
	*:
	*:********************************************************************
	Procedure C2B( m.str)
	Local n, i
	n=0
	For i=Len(m.str) to 1 step -1
		n=BitLshift(n,8)+Asc(Substr(m.str,i,1))
	Next
	Return n
	
EndDefine
*: End of tools.prg
