*:********************************************************************
*:
*: Procedure file :PROCESS.PRG
*:
*: Contents :
*: 
*: 		Class     Process AS Custom
*: 		Procedure Process.INIT
*: 		Procedure Process.RUN
*: 		Procedure Process.WAIT
*: 		Procedure Process.KILL
*: 		Procedure Process.TIMER.TIMER
*: 		Procedure Process.RELEASE
*: 		Procedure INFO
*: 
*: 		Class     MyInfo AS Form
*: 		Procedure MyInfo.INIT
*:
*: (c) Piva, BEAR 33 on 17.10.2001 14:38
*:********************************************************************
* 
*        
*    .
*
* , -  ,      
*       PERL,      
*             
*        perl ,   
*           
*     ,     
*  2 ,      ,     .
* 
*      ...
*
* :
*  
*    (CommandLine)
*      (StartDir)
*  Show ( . ShellExecute, WinExec )
*    RUN
*
*    -  RunAndWait  Fox'
*        
*      
* StandAlone=.T.
*        Interval
* ,     TimeOut - 
*     ,     
*    
*
*   .. 2001, 
* mailto:piva@kurgan.isp.ru
*
*  14:30 , 17  2001 .


#DEFINE cn_Wait		100 && milliseconds   

#define MSG_FAIL	'    "'+.CommandLine+'"'
#define MSG_WAIT	' ESCAPE   '
#define MSG_ESCAPE	' ,   -          ?'
#define MSG_TIMEOUT	'-    .    ?'
#define MSG_NODIE	'   '

* 

x=CreateObject("Process")
With x
	.CommandLine='C:\Program Files\Far\Far.exe'
	.TimeOut=3000	&& 3 
	.StandAlone=.T.
	.Interval=500
	.Run()
endwith

y=CreateObject("Process")
With y
	.CommandLine='C:\Program Files\WinRar\WinRAR.exe'
	.Run()
endwith



*:********************************************************************
*:
*:    Class : PROCESS based on CUSTOM
*:
*:********************************************************************
Define Class Process as Custom
	ProcessID=0		&&  
	TimeOut=0		&& TimeOut  
	CommandLine=""	&&  
	StartDir=""		&&  
	Show=1			&&  nShow
	Self=.null.		&&    
	StandAlone=.F.	&&  
	Interval=0		&&     
	Start=0			&&     
	Elapsed=0		&&     
	
	*      
	Add Object Timer as Timer 
	
	*:********************************************************************
	*:
	*: Method : INIT of class PROCESS
	*:
	*:********************************************************************
	Procedure Init
	*   Windows API
	DECLARE INTEGER WaitForSingleObject IN WIN32API ;
		INTEGER hProcessHandle, ;
		INTEGER dwTimeOut
	
	DECLARE SHORT CreateProcess IN WIN32API ;
		STRING lpszModuleName, ;
		STRING @lpszCommandLine, ;
		STRING lpSecurityAttributesProcess, ;
		STRING lpSecurityAttributesThread, ;
		SHORT bInheritHandles, ;
		INTEGER dwCreateFlags, ;
		STRING lpvEnvironment, ;
		STRING lpszStartupDir, ;
		STRING @lpStartInfo, ;
		STRING @lpProcessInfo
	
	Declare INTEGER GetExitCodeProcess in Win32Api Integer, Integer @
	Declare Integer TerminateProcess in Win32Api Integer, Integer
	
	*:********************************************************************
	*:
	*: Method : RUN of class PROCESS
	*:
	*:********************************************************************
	Procedure Run
	*  
	
	With this
		If Empty(.CommandLine)
			Return .F.
		EndIf
		
		*   
		Local lpStartUpInfo, lpProcessInfo, hResult
		
		lpStartUpInfo = CHR(68) + ;
			REPL(CHR(0),43) + ;
			CHR(1) +  ;
			REPL(CHR(0),3) + ;
			CHR(.Show) + ;
			REPL(CHR(0),19)
		
		lpProcessInfo=REPL(CHR(0),16)
		
		If Empty(.StartDir)
			.StartDir=0
		EndIf
		
		hResult=CreateProcess(;
			0,.CommandLine,;
			0,0,0,0,0,;
			.StartDir,;
			    @lpStartUpInfo,;
			@lpProcessInfo)
		
		
		If hResult < 0
			* Can't create process
			Return .F.
		Else
			.ProcessID = (((ASC(SUBST(lpProcessInfo,4,1))*256) + ;
				ASC(SUBST(lpProcessInfo,3,1)))*256 + ;
				ASC(SUBST(lpProcessInfo,2,1)))*256 + ;
				ASC(LEFT(lpProcessInfo,1))
			
			.Start=Datetime()
		EndIf		
		
		If .StandAlone
			*         
			If not Empty(.Interval)
				.Self=This
				.Timer.Interval=.Interval
			EndIf
		Else
			.Wait()
		EndIf
	EndWith	
	
	*:********************************************************************
	*:
	*: Method : WAIT of class PROCESS
	*:
	*:********************************************************************
	Procedure Wait
	* -   
	With this
		Local m.info, m.nTimeOut, hResult, k
		m.nTimeOut=0
		
		hResult=WaitForSingleObject(.ProcessID, CN_WAIT)
		DO WHILE hResult = 0x0102
			*    ESCAPE   
			IF INKEY() = 27	
				* 4096 -    -     
				k=MessageBox(MSG_ESCAPE,3+32+4096,_SCREEN.Caption)
				do case
				Case k=6
					.Kill()
					Exit
				Case k=7
					Otherwise
					Loop
				EndCase
				Exit
			EndIf
			
			hResult=WaitForSingleObject(.ProcessID, CN_WAIT)
			nTimeOut=nTimeOut+CN_WAIT
			
			if not vartype(m.info)='O' and m.nTimeOut >= 1000 
				*        
				m.info=info(MSG_WAIT)
			endif
			
			If .TimeOut > 0 and nTimeOut > .TimeOut
				*            TimeOut
				If MessageBox(MSG_TIMEOUT,4+48+4096,_SCREEN.Caption)=6
					*  
					.Kill()
					Exit
				Else
					Loop
				EndIf
			EndIf		
			DoEvents()
		 ENDDO
		Release m.info
		
	EndWith
	
	
	*:********************************************************************
	*:
	*: Method : KILL of class PROCESS
	*:
	*:********************************************************************
	Procedure Kill
	*  
	With this
		*    -     ( )
		*       
		* ", ","...","..."
		
		local m.ExitCode
		m.ExitCode=0
		If GetExitCodeProcess(.ProcessID,@ExitCode)=1
			TerminateProcess(.ProcessID,ExitCode)
		Else
			Messagebox(MSG_NODIE,16,_Screen.Caption)
		EndIf
	EndWith
	
	*:********************************************************************
	*:
	*: Method : TIMER.TIMER of class PROCESS
	*:
	*:********************************************************************
	Procedure Timer.Timer
	*        
	With this.parent
		if WaitForSingleObject(.ProcessID,50)=0x0102
			*    
			.Elapsed=.Elapsed+DATETIME()-.Start
			*   TimeOut      -     ...
			if .TimeOut > 0 and DATETIME()-.Start >= .TimeOut/1000
				.Kill()
				.Release
			endif
		else
			.Release
		endif
	EndWith	
	
	*:********************************************************************
	*:
	*: Method : RELEASE of class PROCESS
	*:
	*:********************************************************************
	Procedure Release
	With this
		.Self=.null.
		Release This
	EndWith
	
EndDefine


*:********************************************************************
*:
*: Procedure : INFO
*:
*:********************************************************************
Procedure Info(m.ctext)
Return CreateObject("MyInfo",m.cText)

*:********************************************************************
*:
*:    Class : MYINFO based on FORM
*:
*:********************************************************************
DEFINE Class MyInfo AS Form
	AutoCenter=.T.
	BackColor=RGB(192,192,192)
	BorderStyle=2
	Caption=""
	Height=50
	Width=300
	MinButton=.F.
	MaxButton=.F.
	ControlBox=.F.
	Closable=.F.
	Movable=.F.
	DeskTop=.T.
	MousePointer=11
	
	ADD OBJECT TEXT AS Label WITH ;
		Top=0,;
		Left=0,;
		Height=thisform.Height,;
		Width=thisform.Width ,;
		AutoSize=.T.,;
		Alignment=2,;
		BackStyle=0 ,;
		FontName="Tahoma",;
		FontSize=8,;
		FontBold=.F.,;
		WordWrap=.T.
	
	*:********************************************************************
	*:
	*: Method : INIT of class MYINFO
	*:
	*:********************************************************************
	PROCEDURE Init
	LPARAMETER m.text
	m.text=IIF(TYPE('m.text')#'C'," ...",m.text)
	thisform.TEXT.Caption=m.text
	This.Visible=.T.
	ENDPROC
ENDDEFINE
*: End of PROCESS.PRG
