*:********************************************************************
*:
*: Procedure file :MYFIND.PRG
*:
*: Contents :
*: 
*: 		Class     FindForm AS Form
*: 		Procedure FindForm.CMDOK.CLICK
*: 		Procedure FindForm.CMDCANCEL.CLICK
*: 		Procedure FindForm.LOAD
*: 		Procedure FindForm.INIT
*: 		Procedure FindForm.RESIZE
*: 		Procedure FindForm.TEXT.INTERACTIVECHANGE
*: 		Procedure FindForm.FIND
*: 		Procedure FindForm.ADJUST
*:
*: (c) Piva, BEAR 33 on 31.01.2002 16:05
*:********************************************************************
*
*   Grid
*

Local o
o=CreateObject("FindForm")
If vartype(o)='O'
	o.show
EndIf

*:********************************************************************
*:
*:    Class : FINDFORM based on FORM
*:
*:********************************************************************
Define Class FindForm as Form
	Top=100
	Left=100
	
	Caption=''
	Icon=_Screen.Icon
	
	AlwaysOnTop=.T.
	BorderStyle=2
	DeskTop=.T.
	
	MinButton=.F.
	MaxButton=.F.
	
	Width=320
	Height=100
	
	Form=.null.
	Grid=.null.
	
	Finded=.f.
	Modal=.f.
	
	Me=.null.

	Add Object Label as MyLabel with ;
		FontSize=8,;
		Top=17,;
		Left=15,;
		Caption=''
	
	Add Object Text as MyText with ;
		Top=15,;
		Left=60,;
		Width=150
	
	Add Object cmdOk as MyCmd with ;
		Caption=' ',;
		Default=.T.,;
		Enabled=.F.
	
	Add Object cmdCancel as MyCmd with ;
		Caption='',;
		Cancel=.T.
	
	
	Add Object chkCase as MyCheck with ;
		Top=50,;
		Left=15,;
		Value=.F.,;
		Caption=' \<'
	
	
	Add Object chkWrap as MyCheck with ;
		Top=70,;
		Left=15,;
		Value=.F.,;
		Caption='  \<'
	
	*:********************************************************************
	*:
	*: Method : CMDOK.CLICK of class FINDFORM
	*:
	*:********************************************************************
	Procedure cmdOk.Click
	With thisform
		.Find
	EndWith
	
	*:********************************************************************
	*:
	*: Method : CMDCANCEL.CLICK of class FINDFORM
	*:
	*:********************************************************************
	Procedure cmdCancel.Click
	With thisform
		.Hide
		.Release
	EndWith
	
	*:********************************************************************
	*:
	*: Method : INIT of class FINDFORM
	*:
	*:********************************************************************
	Procedure Init(m.str)
	With this
		.ReSize
		If not Empty(m.str)
			.text.value=m.str
		EndIf
		.cmdOk.Enabled=not empty(.text.value)
		.text.SetFocus
		.Me=This
	EndWith
	
	*:********************************************************************
	*:
	*: Method : RESIZE of class FINDFORM
	*:
	*:********************************************************************
	Procedure ReSize
	With this
		With .cmdOk
			.Top=15
			.Left=This.Width-.Width-10
		EndWith
		With .cmdCancel
			.Top=50
			.Left=This.Width-.Width-10
		EndWith
	EndWith
	
	*:********************************************************************
	*:
	*: Method : TEXT.INTERACTIVECHANGE of class FINDFORM
	*:
	*:********************************************************************
	Procedure Text.InteractiveChange
	ThisForm.cmdOk.Enabled=not Empty(this.value)
	
	*:********************************************************************
	*:
	*: Method : FIND of class FINDFORM
	*:
	*:********************************************************************
	Procedure Find
	With this
		If not .GetGrid()
			Return .F.
		EndIf

		_Screen.MousePointer= 11
		.MousePointer=11
		
		Local m.search, m.case, m.wrap, s, c, m.count, p
		m.search=alltrim(.text.Value)
		m.case=.chkCase.value
		m.wrap=.chkWrap.value
		
		Select (.Grid.RecordSource) 
		m.rc=Recno()
		If .Finded
			If not Eof()
				Skip
				If Eof()
					Go Bottom
				EndIf
			EndIf
		EndIf
		
		.Finded=.F.
		m.count=0
		do while .t.
			Scan rest
				For i=1 to .Grid.ColumnCount
					p=""
					if not empty(.Grid.Columns[i].Format)
						p='@'+.Grid.Columns[i].Format
					endif
					if not empty(.Grid.Columns[i].InputMask)
						p=p+" "+.Grid.Columns[i].InputMask
					endif
					c=Evaluate(.Grid.Columns[i].ControlSource)
					s=Transform(c,p)
					If m.case
						If At(m.search,s)>0
							.Finded=.T.
							Exit
						EndIf
					Else
						If Atc(m.search,s)>0
							.Finded=.T.
							Exit
						EndIf
					EndIf
				Next
				If .Finded
					Exit
				EndIf
			EndScan
			If .Finded
				Exit
			EndIf
			If m.wrap
				Go Top
			endif
			m.count=m.count+1
			if not .Finded and m.count >= 2
				exit
			endif
		EndDo
		
		.MousePointer=0
		_Screen.MousePointer=0
		
		If not .Finded
			*			.Grid.Setall('HideSelection',.T.)
			Go (m.rc)
			MessageBox("  .",64,.Caption)
		Else
			if not empty(.Grid.LinkMaster)
				m.rc=recno()
				local xx, xval
				xx=(.Grid.RelationalExpr)
				xval=eval(xx)
				select (.Grid.LinkMaster)
				locate for &xx=xval
				.Form.Refresh
				select (.Grid.RecordSource)
				go m.rc
			endif
		
			.Grid.Columns[i].SetFocus
		
			if .Modal
				.Release
			endif
			
			.Adjust()

*			.Show
			
		EndIf
		.Grid=.null.
		.Form=.null.
	EndWith
	
	*:********************************************************************
	*:
	*: Method : ADJUST of class FINDFORM
	*:
	*:********************************************************************
	Procedure Adjust
	With this
		Local m.top, m.left, m.off
		
		m.top=Objtoclient(.Form,1)
		m.left=Objtoclient(.Form,2)
		
		*   .ActiveColumn   .RelativeColumn > 1
		*    .ColumnOrder 

		m.off=0
		
		With .Grid
			If .RelativeColumn > 1
				For i=1 to .ColumnCount 
					If Between(.Columns[i].ColumnOrder,.ActiveColumn-.RelativeColumn+1,.ActiveColumn-1)
						m.off=m.off+.Columns[i].Width+.GridLineWidth
					EndIf
				Next
			EndIf
			*  -    ,   grid,   Sizeble Frame Height
			m.Top=m.Top+.HeaderHeight+(.RowHeight)*.RelativeRow+Sysmetric(9)+Sysmetric(4)
		EndWith
		
		m.off=m.off+1 &&  
		
		.Top=m.Top
		.Left=m.Left+m.off+Sysmetric(3)
		
		If .Grid.RecordMark
			.Left=.Left+9
		EndIf
		If .Grid.DeleteMark
			.Left=.Left+9
		EndIf
		
		*       
		
		If .Left < 0
			.Left=0
		EndIf
		If .Top < 0
			.Top=0
		EndIf
		If .Left+.Width > Sysmetric(1)
			.Left=Sysmetric(1)-.Width
		EndIf
		If .Top+.Height+26> Sysmetric(2)
			.Top=.Top-.Height-.Grid.RowHeight-1-sysmetric(9)-sysmetric(4)
		EndIf
		
	EndWith

	Procedure GetGrid
	*    Grid 	
	With this
		Local ret, o, l, oForm
		ret=.F.
		.Grid=.null.
		.Form=.null.

		l=.F.
		For each o in _Screen.Forms
				If o.caption=.caption
					l = .T.
				Else
					If l and o.baseclass='Form'
						oForm=o
						Exit
					EndIf
				EndIf
		Next
		If Vartype(oForm)='O' and PemStatus(oForm,'ActiveGrid',5)
			If oForm.ActiveGrid.BaseClass='Grid'
				.Grid=oForm.ActiveGrid
				.Form=oForm
				Ret=.T.
			EndIf
		EndIf
		Return Ret
	EndWith
	
EndDefine

*: End of MYFIND.PRG
