*:********************************************************************
*:
*: Procedure file :SETUP.PRG
*:
*: Contents :
*: 		Procedure OPEN
*: 		Procedure READ
*: 		Procedure SAVE
*:
*: (c) Piva, BEAR 0.04 on 07.02.2000 00:17
*:********************************************************************
*-------------------------------------------
* Jack.J7
*
*   
*
*   .. 1999
*------------------------------------------

#include include\main.h


Define Class Setup as BaseClass
	Title=""
	Alias="CONFIG"
	Form=.null.
	Default=''			&& default boot path
	Tables='tables'		&& path to tables
	Reports='reports'	
	Images='images'
	PlugIns='plugins'
	PictureFile=''
	Icon=''
	BackColor=-1
	ScreenCaption=""
	FontName="Arial"
	FontSize=8

	Procedure Init
	with this
		if DoDefault()
			if not This.StartUp()
				_IsShutdown=.T.
				Return .F.				
			endif
		endif
		if WEXIST('Standard')
			Release Window Standard
		endif
	endwith

	Procedure Setup
	with this
		Local o, x

		_Tables=addbs(GetLocalProfile("Boot",'Tables','.'))
		_Reports=addbs(GetLocalProfile("Boot",'Reports','.'))
		_Images=addbs(GetLocalProfile("Boot",'Images','.'))
		_PlugIns=addbs(GetLocalProfile("Boot",'PlugIns','.'))

		_TITLE=GetGlobalProfile("Boot","Title",_TITLE)

		_Pic_Summa	=GetGlobalProfile("Format",'Summa',_Pic_Summa)
		_Pic_Total	=GetGlobalProfile("Format",'Total',_Pic_Total)
		_Pic_Amount	=GetGlobalProfile("Format",'Amount',_Pic_Amount)
		_Pic_Price	=GetGlobalProfile("Format",'Price',_Pic_Price)
		_Pic_Count	=GetGlobalProfile("Format",'Count',_Pic_Count)
		_Pic_Percent=GetGlobalProfile("Format",'Percent',_Pic_Percent)
		_Pic_Bucks	=GetGlobalProfile("Format",'Bucks',_Pic_Bucks)
		_Pic_Number	=GetGlobalProfile("Format",'Number',_Pic_Number)

		_Round		=GetGlobalProfile("Format",'Round',_Round)
		_Tax_Round	=GetGlobalProfile("Format",'TaxRound',_Tax_Round)

		**** Set any system parameters
		x=GetGlobalProfile("Format",'Point',',')
		SET Point to (x)
		x=GetGlobalProfile("Format",'Decimal',2)
		SET Decimal to (x)

		IF Left(_Tables,2)="\\" and Not SetNetName(_Tables)
			RETURN .F.
		ENDIF
		IF Left(_Reports,2)="\\" and Not SetNetName(_Reports)
			RETURN .F.
		ENDIF
		IF Left(_Images,2)="\\" and Not SetNetName(_Images)
			RETURN .F.
		ENDIF

		*** Set any runtime parameters

		if empty(.Default) and not empty(_tables)
			.Default=_tables
		endif

		.Interior()
	
	endwith

	Procedure Set
	with this
		Do Form Setup with this name This.Form linked
	endwith

	Procedure Read
	with this
		if vartype(.Form)='O'
			with .Form.PageFrame.Page1
				.chkQuit.Value=GetLocalProfile("Boot","Quit",.T.)
				.chkConfirm.Value=GetLocalProfile("Boot","ExitConfirm",.T.)
				.chkPrompt.Value=GetLocalProfile("Print","Prompt",.F.)

				.txtTitle.Value=GetLocalProfile("Desktop","Caption","")
				.txtIconFile.Value=GetLocalProfile("Desktop","Icon","")
				.txtWallPaper.Value=GetLocalProfile("Desktop","WallPaper",'')

				.chkQuit.Enabled=_vfp.StartMode=0


			endwith
			with .Form.PageFrame.Page2
				.txtTables.Value=GetLocalProfile("Boot",'Tables',_tables)
				.txtReports.Value=GetLocalProfile("Boot",'Reports',_reports)
*				.txtImages.Value=GetLocalProfile("Boot",'Images',_images)
				.txtPlugins.Value=GetLocalProfile("Boot",'Plugins',_plugins)
			endwith
			with .Form.PageFrame.Page3
				.cboOwner.Value=GetGlobalProfile("Default","Common.Owner","")
				.txtNDS.Value=GetGlobalProfile("Default","Common.NDS",20)
				.txtTax.Value=GetGlobalProfile("Default","Common.Tax",5)
			endwith
		endif
	endwith

	Procedure Write
	with this
		with .Form.PageFrame.Page1
			SetLocalProfile('Boot','Quit',.chkQuit.Value)
			SetLocalProfile('Boot','ExitConfirm',.chkConfirm.Value)

			SetLocalProfile("Print","Prompt",.chkPrompt.Value)
			
			SetLocalProfile('Desktop','Icon',.txtIconFile.Value)
			SetLocalProfile('Desktop','WallPaper',.txtWallPaper.Value)
			SetLocalProfile('Desktop','Caption',alltrim(.txtTitle.Value))
			SetLocalProfile('Desktop','BackColor',-1)

		endwith
		with .Form.PageFrame.Page2
			SetLocalProfile("Boot",'Tables',alltrim(.txtTables.Value))
			SetLocalProfile("Boot",'Reports',alltrim(.txtReports.Value))
*			SetLocalProfile("Boot",'Images',alltrim(.txtImages.Value))
			SetLocalProfile("Boot",'Plugins',alltrim(.txtPlugins.Value))
		endwith
		with .Form.PageFrame.Page3
			SetGlobalProfile("Default","Common.Owner",.cboOwner.Value)
			SetGlobalProfile("Default","Common.Tax",.txtTax.Value)
			SetGlobalProfile("Default","Common.Tax",.txtTax.Value)
		endwith

		.Interior()
	
	endwith		

	Procedure Interior
	with this
		.ScreenCaption=GetLocalProfile("DeskTop","Caption","")
		.Icon=GetLocalProfile("DeskTop",'Icon',"")
		.PictureFile=GetLocalProfile("DeskTop",'WallPaper','')
		.BackColor=GetLocalProfile("DeskTop",'BackColor',GetSysColor(5))
		.FontName=GetLocalProfile("Font","Name",_FontName)
		.FontSize=GetLocalProfile("Font","Size",8)


		_SCREEN.caption=.ScreenCaption
		_SCREEN.icon=Iif(File(.Icon),.Icon,"")
		_SCREEN.picture=Iif(File(.PictureFile),.PictureFile,"")
		_SCREEN.backcolor=.BackColor

		_FontName=.FontName
		_FontSize=.FontSize

	endwith

	Procedure StartUp
	with this
		if not .Setup()
			Return .F.
		endif

		if Not Uses()
			Return .F.
		endif
	endwith

	Procedure ReBoot
	with this
		local m.location, o, m.current, m.caption, info
		m.current=_tables
		do form Boot to m.Location
		if not empty(m.Location)
			info=info(" ")
			for each o in .parent.document
				if not .Close()
					Return .F.
				endif
			next
			set database to (DATABASE_NAME)
			close database
			info.text=" "
			_tables=addbs(m.location)
			if not uses()
				MessageBox("   .   .         .",48,MYTITLE)

				info.text="  "
				
				_tables=addbs(m.current)
				if not uses()
					MessageBox("   .  ",48,MYTITLE)
					* 
				endif
			endif
			if CompareDir(_tables,.default)
				_screen.caption=.ScreenCaption
			else
				m.caption=GetGlobalProfile("boot",'title','')
				if empty(m.caption)
					_screen.caption=.ScreenCaption+"  ("+_tables+")"
				else
					_screen.caption=.ScreenCaption+"  ("+m.caption+")"
				endif					
			endif
		endif
	endwith

	Procedure Destroy
	With this
		DoDefault()
		USE in Select("Users")
		USE in Select("UsersGrp")
		USE in Select("Grant")
		USE in Select("Support")
	EndWith

EndDefine

