*:********************************************************************
*:
*: Procedure file :uses.prg
*:
*: Contents :
*: 
*: 		Class     UseTables AS Custom
*:
*: (c) Piva, BEAR v.43 on 12.05.2003 09:54
*:********************************************************************
#Define 	BoxTitle		" "

#include Include/Main.h

If Vartype(_Tables) # 'C'
	Local m.path
	m.path=GetFolder()
	If Empty(m.path)
		Messagebox("     .",16,BoxTitle)
		Return .F.
	Endif
	Public _Tables
	_Tables=m.path
Endif

Local o, i, k,tmp[1],F
o=Newobject("UseTables")
If Vartype(o)='O'
	With o
		F=.T.
		k=Adbobject(tmp,'TABLE')
		For i=1 To k
			F=F And .Use(tmp[i])
		Next
		If Not F
			For i=1 To Select(1)
				If Used(i) And Justext(Dbf(i))='DBF'
					Use In Select(i)
				Endif
			Next
			Return .F.
		Endif
	Endwith
Else
	Return .F.
Endif

*:********************************************************************
*:
*: Procedure : Reindex
*:
*:********************************************************************
Procedure Reindex
Private Info
Info=Info(' ')
Local o, T, i, k
o=Newobject("UseTables")
If Vartype(o)='O'
	k=Aused(tmp)
	Dimension Usage[k,2]
	For i=1 To k
		Usage[i,1]=tmp[i,1]
		Usage[i,2]=Dbf(tmp[i,1])
	Next
	For i=1 To k
		If '.DBF' $ Usage[i,2]
			Use In Select(Usage[i,1])
		Endif
	Next
	
	T=.T.
	With o
		k=Adbobjects(tmp,'TABLE')
		For i=1 To k
			T=T And .Reindex(tmp[i])
		Next
		
		For i=1 To Alen(Usage,1)
			If Not Used(Usage[i,1])
				If '.DBF' $ Usage[i,2]
					Use (Usage[i,2]) Again In 0 Alias (Usage[i,1])
				Endif
			Endif
		Next
		Return T
	Endwith
Else
	Return .F.
Endif


*:********************************************************************
*:
*:    Class : UseTables based on Custom
*:
*:********************************************************************
Define Class UseTables As Custom
	DBFName=""
	DBFTitle=""
	Alias=""
	nError=0
	cMessage=""
	cSource=""
	cMethod=""
	nLine=0
	Host=""
	Caption=" "
	
	*:********************************************************************
	*:
	*: Method : Init of class UseTables
	*:
	*:********************************************************************
	Procedure Init
	With this
		If Not .IsReady(_Tables)
			Return .F.
		Endif
		If Not .CheckDataBase(_Tables)
			Messagebox('  ("'+DATABASE_NAME+'")      "'+_Tables+'".',48,This.Caption)
			m.basepath=m.GetFolder("","   ")
			If not Empty(m.basepath)
				If .IsReady(m.BasePath) and .CheckDataBase(m.BasePath)
					_Tables=Path(m.BasePath,1)
					PutProfile("boot","Tables",_Tables)
				Else
					Return .F.
				EndIf
			Else
				Return .F.
			EndIf
		Endif
		.nError=0
		Open Data (Addbs(_Tables)+DATABASE_NAME) Shared
	EndWith

	Procedure CheckDataBase(m.cPath)
	With this
		If File(Addbs(m.cPath)+DATABASE_NAME+'.DBC') ;
		and File(Addbs(m.cPath)+DATABASE_NAME+'.DCT') ;
		and File(Addbs(m.cPath)+DATABASE_NAME+'.DCX') ;
		and File(Addbs(m.cPath)+DATABASE_NAME+'.INF') 
		
			Return .T.

		EndIf 
		Return .F.
	EndWith

	
	*:********************************************************************
	*:
	*: Method : IsReady of class UseTables
	*:
	*:********************************************************************
	Procedure IsReady( tcPath )
	If Vartype(tcPath)='C'
		tcPath=Full(tcPath)
		If Left(tcPath,2)='\\' 	&& Direct Network access (UNC)
			Local m.Server
			m.Server=Getwordnum(tcPath,1,"\")
			If Anetresources(tmp,m.Server,1)=0
				Messagebox(" "+m.Server+"  ."+Chr(13)+;
					" ("+tcPath+")  .",48,'')
				Return .F.
			Endif
		Else
			If Inlist(Drivetype(tcPath),1,6)
				Local m.Drive
				m.Drive=Justdrive(tcPath)
				
				Messagebox(" "+m.Drive+"    .",16,This.Caption)
				Return .F.
			Endif
		Endif
	Else
		Messagebox("    .",16,This.Caption)
		Return .F.
	Endif
	
	
	*:********************************************************************
	*:
	*: Method : Use of class UseTables
	*:
	*:********************************************************************
	Procedure Use( tcDBFName, tcAlias)
	Local m.cFullDBFPathName
	With This
		If Vartype( tcDBFName )='C'
			tcAlias=Iif(Empty(tcAlias),Juststem(tcDBFName),tcAlias)
			.FullDBFName( tcDBFName )
			If Not Used(tcAlias)
				If Not File(.DBFName)
					Messagebox(" "+.DBFName+"  .",16,.Caption)
					Return .F.
				Endif
				This.nError=0
				Use (.DBFName) In 0 Alias (tcAlias) Again
				If .nError # 0
					Messagebox("a     "+tcAlias,48,.Caption)
					Return .F.
				Endif
			Endif
			If Isreadonly( tcAlias )
				Messagebox(" "+TableName(tcAlias)+"    ",16,.Caption)
			Endif
			
		Endif
	Endwith
	
	*:********************************************************************
	*:
	*: Method : Reindex of class UseTables
	*:
	*:********************************************************************
	Procedure Reindex( tcAlias )
	*   
	*        REINDEX.INI
	* [alias]
	* tag_name=field_expression;for_exression;option;cdx_name
	* option:
	* 0 -(default) compact
	* 1 - unique
	* 2 - candidate
	*    cdx   idx 
	*      ;;
		*
	Local m.ini,m.ReindexIni, m.cdx, m.tag, m.key, m.for, m.option, s, i, l,;
		m.old
	Local Array aEnt[1]
	
	With This
		m.old=Select()
		If !Used(tcAlias)
			.FullDBFName(tcAlias)
			If Not File(.DBFName)
				Return .F.
			Endif
			
			Select 0
			Use (.DBFName) Exclusive
		Else
			Select (tcAlias)
			Use Dbf() Exclusive
		Endif
		If Not Isexclusive()
			Select (m.old)
			Return .F.
		Endif
		Select (tcAlias)
		Info.Text='  '+CR+TableName(tcAlias)
		
		*      
		m.ReindexIni=Full(Addbs(_Tables)+REINDEX_INF)
		If Not File(m.ReindexIni)
			Use (Dbf()) Shared
			Select (m.old)
			Return .F.
		Endif
		If ProfileSection(@aEnt,tcAlias,m.ReindexIni)=0
			Delete Tag All
			For i=1 To Alen(aEnt,1)
				s=Profile(tcAlias,aEnt[i],"",m.ReindexIni)
				If Not Empty(s)
					m.tag=aEnt[i]
					m.key=WordNumEx(s,1,';')
					m.for=WordNumEx(s,2,';')
					m.option=WordNumEx(s,3,';')
					m.cdx=WordNumEx(s,4,';')
					
					s=""
					If Val(m.option) > 0
						Do Case
						Case m.option=1
							s=s+" UNIQUE"
						Case m.option=2
							s=s+" CANDIDATE "
						Endcase
					Endif
					If Not Empty(m.cdx)
						s=s+" OF "+m.cdx
					Else
						s=s+" OF "+Forceext(Dbf(),"CDX")
					Endif
					
					Index On &Key Tag &Tag &s
					
				Endif
			Next
		Endif
		Use (Dbf()) Shared
		Select (m.old)
	Endwith
	
	*:********************************************************************
	*:
	*: Method : FullDBFName of class UseTables
	*:
	*:********************************************************************
	Procedure FullDBFName( tcDBFName )
	Local cAlias
	With This
		cAlias=Juststem(tcDBFName)
		If Not Used(cAlias)
			.DBFName=Full(Addbs(_Tables)+DefaultExt(tcDBFName,'DBF'))
		Else
			.DBFName=Dbf(cAlias)
		Endif
		
		.DBFTitle=DBGetProp(cAlias,"TABLE","COMMENT")
		If Empty(.DBFTitle)
			.DBFTitle=cAlias
		Endif
		Return .DBFName
	Endwith
	
	*:********************************************************************
	*:
	*: Method : Error of class UseTables
	*:
	*:********************************************************************
	Procedure Error (nError, cMethod, nLine	)
	With This
		Do Case
		Case Inlist(nError,1705,1569) && Access denied
			Return .T.
		Case Inlist(nError,1707) && 1707
			Return .T.
		Case Inlist(nError,1562) &&  Cannot find object "name" in the database.
			Return .T.
		Case Inlist(nError,1561) &&  Database is invalid. Please validate
			Return .T.
		Endcase
		
		Logerror(nError, cMethod, nLine)
		
		.nError=nError
		.cMessage=Message()
		.cSource=Message(1)
		.nLine=0
		.cMethod=""
		
		Messagebox(	' :'+Chr(9)+.cMessage+Chr(13)+;
			' :'+Chr(9)+'"'+.cMethod+'"'+Chr(13)+;
			' :'+Chr(9)+Ltrim(Tran(.nLine,'@Z'));
			,16,'  '+num(.nError))
		
	Endwith
	
Enddefine

*: End of uses.prg
